import { InjectionToken } from '@angular/core';
import { Http } from '@angular/http';
import { Observable } from 'rxjs/Observable';
import { StoreModel } from './store-model';
export declare let APP_CONFIG: InjectionToken<IAppConfig>;
import 'rxjs/add/operator/delay';
export interface IAppConfig {
    apiEndpoint: string;
}
export declare const AppConfig: IAppConfig;
export declare class EntityService {
    private _http;
    private config;
    constructor(_http: Http, config: IAppConfig);
    getEntities<T extends StoreModel = StoreModel>(entityName: string): Observable<StoreModel[]>;
    addEntity(entityName: string, entity: StoreModel): Observable<StoreModel>;
    editEntity(entityName: string, entity: StoreModel): Observable<StoreModel>;
    deleteEntity(entityName: string, entity: StoreModel): Observable<StoreModel>;
}
