import { Injectable, Inject, InjectionToken } from '@angular/core';
import { Http, RequestOptions, Headers } from '@angular/http';
export var APP_CONFIG = new InjectionToken('app.config');
import 'rxjs/add/operator/delay';
export var AppConfig = {
    apiEndpoint: '/api/'
};
var EntityService = (function () {
    function EntityService(_http, config) {
        this._http = _http;
        this.config = config;
    }
    EntityService.prototype.getEntities = function (entityName) {
        return this._http
            .get(this.config.apiEndpoint + "/" + entityName + "s")
            .delay(1000)
            .map(function (res) { return res.json(); });
    };
    EntityService.prototype.addEntity = function (entityName, entity) {
        var headers = new Headers({ 'Content-Type': 'application/json' });
        var options = new RequestOptions({ headers: headers });
        console.log(' am i called here');
        return this._http
            .post(this.config.apiEndpoint + "/" + entityName + "s", entity)
            .map(function (res) { return res.json(); });
    };
    EntityService.prototype.editEntity = function (entityName, entity) {
        var headers = new Headers({ 'Content-Type': 'application/json' });
        var options = new RequestOptions({ headers: headers });
        return this._http
            .put(this.config.apiEndpoint + "/" + entityName + "s", entity)
            .map(function (res) { return res.json(); });
    };
    EntityService.prototype.deleteEntity = function (entityName, entity) {
        var headers = new Headers({ 'Content-Type': 'application/json' });
        var options = new RequestOptions({ headers: headers });
        // return Observable.of(entitiy).delay(1000).map()
        return this._http
            .delete(this.config.apiEndpoint + "/" + entityName + "s")
            .map(function (res) { return res.json(); });
    };
    EntityService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    EntityService.ctorParameters = function () { return [
        { type: Http, },
        { type: undefined, decorators: [{ type: Inject, args: [APP_CONFIG,] },] },
    ]; };
    return EntityService;
}());
export { EntityService };
//# sourceMappingURL=entity.service.js.map