import { ActionReducerMap, MemoizedSelector } from '@ngrx/store';
import { StoreModel } from '.';
import 'reflect-metadata';
export declare function compareEntities(arg1: any, arg2: any): boolean;
export declare type EntityStatus = {
    progress: boolean;
    error: any;
};
export declare type EntityState = {
    [entityName: string]: EntityMainState<StoreModel>;
};
export declare const getEntityFeatureState: MemoizedSelector<object, EntityState>;
export declare const entityState: {
    [key: string]: MemoizedSelector<object, BaseState>;
};
export declare const entityLoadStatusState: {
    [key: string]: MemoizedSelector<object, EntityStatus>;
};
export declare const entityAddStatusState: {
    [key: string]: MemoizedSelector<object, EntityStatus>;
};
export declare const entityEditStatusState: {
    [key: string]: MemoizedSelector<object, EntityStatus>;
};
export declare const entityDeleteStatusState: {
    [key: string]: MemoizedSelector<object, EntityStatus>;
};
export declare const entityListState: {
    [key: string]: MemoizedSelector<object, StoreModel[]>;
};
export declare const entitySelectedIdState: {
    [key: string]: MemoizedSelector<object, string | number | null>;
};
export declare function getEntityState(entityName: string): MemoizedSelector<object, EntityMainState<StoreModel>>;
export declare function getEntities<T extends StoreModel>(entityName: string): MemoizedSelector<object, T[]>;
export declare function getSelectedEntityId<T extends StoreModel>(entityName: string): MemoizedSelector<object, string | number | null>;
export declare function getEntityAddStatus(entityName: string): MemoizedSelector<object, EntityStatus>;
export declare function getEntityEditStatus(entityName: string): MemoizedSelector<object, EntityStatus>;
export declare function getEntityDeleteStatus(entityName: string): MemoizedSelector<object, EntityStatus>;
export declare function getEntityLoadStatus(entityName: string): MemoizedSelector<object, EntityStatus>;
export declare function getInitStatus(): Status;
export declare function getInitialState<T>(): EntityMainState<T>;
export declare type Status = {
    [key in 'load' | 'add' | 'edit' | 'delete']: {
        progress: boolean;
        error: any;
    };
};
export interface EntityMainState<T> {
    selectedEntityId: string | number | null;
    entities: T[] | null;
    status: Status;
}
export declare type BaseState = EntityMainState<StoreModel>;
export declare function getReducerr(entities: string[]): ActionReducerMap<BaseState>;
