import { createSelector, createFeatureSelector } from '@ngrx/store';
import 'reflect-metadata';
// export interface State<T> {
//   'entity': EntityState<T>;
// }
// // TODO: Give proper types
// const entityState: { [key: string]: any } = {};
// const entities: { [key: string]: any } = {};
// const actions: { [key: string]: any } = {};
// const loadStatus: { [key: string]: any } = {};
// function init<T>(c: { name: string }) {
//   const entityName = c.name;
//   const entityAction: ActionCollection<T> = getEntityAction(c);
//   actions[entityName] = entityAction;
//   entityState[entityName] = createFeatureSelector<EntityState<T>>(entityName);
//   entities[entityName] = createSelector(
//     entityState[entityName],
//     getStateEntities
//   );
//   loadStatus[entityName] = createSelector(
//     entityState[entityName],
//     getStateLoadStatus
//   );
// }
// export function getEntities<T>(c: { name: string }) {
//   if (!entities[c.name]) {
//     init<T>(c);
//   }
//   return entities[c.name];
// }
// export function getAction<T>(c: { name: string }) {
//   if (!actions[c.name]) {
//     init<T>(c);
//   }
//   return actions[c.name];
// }
// export function getLoadStatus<T>(c: { name: string }) {
//   if (!loadStatus[c.name]) {
//     init<T>(c);
//   }
//   return loadStatus[c.name];
// }
// export interface EntityState<T> {
//   entities: T[] | null;
//   selectedEntityId: string | number;
//   status: Status;
// }
// export const getStateEntities = <T>(state: EntityState<T>) => {
//   console.log('getStateEntities', state);
//   return state && state.entities;
// };
// export const getStateLoadStatus = <T>(state: EntityState<T>) => {
//   console.log('getStateLoadStatus', state);
//   return state && state.status && state.status.load;
// };
// // export const getStateAddStatus = <T>(state: EntityState<T>) => state.status.add;
// // export const getStateEditStatus = <T>(state: EntityState<T>) =>
// //   state.status.edit;
// // export const getStateDeleteStatus = <T>(state: EntityState<T>) =>
// //   state.status.delete;
// export const getSelectedId = <T>(state: EntityState<T>) =>
//   state.selectedEntityId;
export function compareEntities(arg1, arg2) {
    return arg1.id === arg2.id;
}
export var getEntityFeatureState = createFeatureSelector('entity');
export var entityState = {};
export var entityLoadStatusState = {};
export var entityAddStatusState = {};
export var entityEditStatusState = {};
export var entityDeleteStatusState = {};
export var entityListState = {};
export var entitySelectedIdState = {};
export function getEntityState(entityName) {
    if (!entityState[entityName]) {
        entityState[entityName] = createSelector(getEntityFeatureState, function (state) { return state[entityName]; });
    }
    return entityState[entityName];
}
export function getEntities(entityName) {
    if (!entityListState[entityName]) {
        entityListState[entityName] = createSelector(getEntityState(entityName), function (state) { return state.entities; });
    }
    return entityListState[entityName];
}
export function getSelectedEntityId(entityName) {
    if (!entitySelectedIdState[entityName]) {
        entitySelectedIdState[entityName] = createSelector(getEntityState(entityName), function (state) { return state.selectedEntityId; });
    }
    return entitySelectedIdState[entityName];
}
export function getEntityAddStatus(entityName) {
    if (!entityAddStatusState[entityName]) {
        entityAddStatusState[entityName] = createSelector(getEntityState(entityName), function (state) { return state.status.add; });
    }
    return entityAddStatusState[entityName];
}
export function getEntityEditStatus(entityName) {
    if (!entityEditStatusState[entityName]) {
        entityEditStatusState[entityName] = createSelector(getEntityState(entityName), function (state) { return state.status.edit; });
    }
    return entityEditStatusState[entityName];
}
export function getEntityDeleteStatus(entityName) {
    if (!entityDeleteStatusState[entityName]) {
        entityDeleteStatusState[entityName] = createSelector(getEntityState(entityName), function (state) { return state.status.delete; });
    }
    return entityDeleteStatusState[entityName];
}
export function getEntityLoadStatus(entityName) {
    if (!entityLoadStatusState[entityName]) {
        entityLoadStatusState[entityName] = createSelector(getEntityState(entityName), function (state) { return state.status.load; });
    }
    return entityLoadStatusState[entityName];
}
// createSelector(getEntityFeatureState, state => state.);
export function getInitStatus() {
    return {
        load: { progress: false, error: null },
        add: { progress: false, error: null },
        edit: { progress: false, error: null },
        delete: { progress: false, error: null }
    };
}
export function getInitialState() {
    return {
        entities: null,
        selectedEntityId: null,
        status: getInitStatus()
    };
}
export function getReducerr(entities) {
    return entities.reduce(function (acc, entity) {
        return Object.assign(acc, (_a = {},
            _a[entity] = function (state, action) {
                // return state;
                if (state === void 0) { state = getInitialState(); }
                var type = action.type;
                switch (type) {
                    case entity + '/selected':
                        return Object.assign({}, state, {
                            selectedEntityId: action
                                .payload
                        });
                    case entity + '/load':
                        var initStatus = state.status;
                        initStatus.load.progress = true;
                        return {
                            entities: state.entities,
                            selectedEntityId: state.selectedEntityId,
                            status: initStatus
                        };
                    case entity + '/load/success':
                        return {
                            entities: action.payload,
                            selectedEntityId: state.selectedEntityId,
                            status: Object.assign(state.status, {
                                load: {
                                    progress: false,
                                    error: null
                                }
                            })
                        };
                    case entity + '/load/error':
                        return Object.assign({}, state, {
                            status: Object.assign({}, state.status, {
                                load: {
                                    progress: false,
                                    error: action.payload
                                }
                            })
                        });
                    case entity + '/add':
                        return {
                            entities: state.entities,
                            selectedEntityId: state.selectedEntityId,
                            status: Object.assign({}, state.status, {
                                add: {
                                    progress: true,
                                    error: null
                                }
                            })
                        };
                    case entity + '/add/success':
                        return {
                            entities: (state.entities === null ? [] : state.entities).concat([
                                action.payload
                            ]),
                            selectedEntityId: state.selectedEntityId,
                            status: Object.assign({}, state.status, {
                                add: {
                                    progress: false,
                                    error: null
                                }
                            })
                        };
                    case entity + '/add/error':
                        return {
                            entities: state.entities,
                            selectedEntityId: state.selectedEntityId,
                            status: Object.assign(state.status, {
                                add: {
                                    progress: false,
                                    error: action.payload
                                }
                            })
                        };
                    case entity + '/edit':
                        return {
                            entities: state.entities,
                            selectedEntityId: state.selectedEntityId,
                            status: Object.assign(state.status, {
                                edit: {
                                    progress: true,
                                    error: null
                                }
                            })
                        };
                    case entity + '/edit/success':
                        return {
                            entities: (state.entities === null
                                ? []
                                : state.entities).map(function (entity) {
                                // TODO: need to fix isEqual is not a function error for following code
                                // return entity.isEqual(
                                //   (<EditSuccessAction<StoreModel>>action).payload
                                // )
                                return compareEntities(entity, action.payload)
                                    ? (entity = action.payload)
                                    : entity;
                            }),
                            selectedEntityId: state.selectedEntityId,
                            status: Object.assign(state.status, {
                                edit: {
                                    progress: false,
                                    error: null
                                }
                            })
                        };
                    case entity + '/edit/error':
                        return {
                            entities: state.entities,
                            selectedEntityId: state.selectedEntityId,
                            status: Object.assign(state.status, {
                                edit: {
                                    progress: false,
                                    error: action.payload
                                }
                            })
                        };
                    case entity + '/delete':
                        return {
                            entities: state.entities,
                            selectedEntityId: state.selectedEntityId,
                            status: Object.assign(state.status, {
                                delete: {
                                    progress: true,
                                    error: null
                                }
                            })
                        };
                    case entity + '/delete/success':
                        return {
                            entities: (state.entities === null
                                ? []
                                : state.entities).filter(function (entity) {
                                // TODO: need to fix isEqual is not a function error for following code
                                // return entity.isEqual((<DeleteSuccessAction<
                                //   StoreModel
                                // >>action).payload)
                                return compareEntities(entity, action.payload)
                                    ? false
                                    : entity;
                            }),
                            selectedEntityId: state.selectedEntityId,
                            status: Object.assign(state.status, {
                                delete: {
                                    progress: false,
                                    error: null
                                }
                            })
                        };
                    case entity + '/delete/error':
                        return {
                            entities: state.entities,
                            selectedEntityId: state.selectedEntityId,
                            status: Object.assign(state.status, {
                                delete: {
                                    progress: false,
                                    error: action.payload
                                }
                            })
                        };
                    default:
                        return state;
                }
            },
            _a));
        var _a;
    }, {});
}
//# sourceMappingURL=reducers.js.map